/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.process.service;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.ELog;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QFKDAO;
import it.eng.spagobi.kpi.utils.AbstractConfigurableListModule;

import java.util.Date;
import java.util.HashMap;
import java.util.List;

import org.apache.log4j.Logger;

public class ListELogModule extends AbstractConfigurableListModule {

	private static transient Logger logger = Logger
			.getLogger(ListELogModule.class);

	@Override
	public void service(SourceBean request, SourceBean response)
			throws Exception {

		super.service(request, response);

		String operationId = (String) request.getAttribute("OPERATION_ID");

		HashMap parametersMap = (HashMap) response
				.getAttribute("PARAMETERS_MAP");
		if (parametersMap == null) {
			parametersMap = new HashMap();
			parametersMap.put("OPERATION_ID", operationId);
			response.setAttribute("PARAMETERS_MAP", parametersMap);
		} else {
			parametersMap.put("OPERATION_ID", operationId);
			response.updAttribute("PARAMETERS_MAP", parametersMap);
		}
	}

	@Override
	protected List getObjectList(SourceBean request) {
		String fieldOrder = (String) request.getAttribute("FIELD_ORDER");
		String typeOrder = (String) request.getAttribute("TYPE_ORDER");
		List result = null;
		try {
			String operationId = (String) request.getAttribute("OPERATION_ID");
			if (operationId != null && !operationId.trim().equals("")) {
				IES4QFKDAO iELogDAO = (IES4QFKDAO) DAOFactory
						.getDAO("ELogDAO");
				result = iELogDAO.loadObjectList(Integer
						.parseInt(operationId), fieldOrder, typeOrder);
			}
		} catch (EMFUserError e) {
			logger.error(e);
		}
		return result;
	}

	@Override
	protected void setRowAttribute(SourceBean rowSB, Object obj)
			throws SourceBeanException {
		ELog aLog = (ELog) obj;
		Integer extracted = aLog.getExtracted();
		Integer inserted = aLog.getInserted();
		Date operationTime = aLog.getOperationDate();
		
		rowSB.setAttribute("ID", aLog.getIdLog());
		
		if(extracted != null) {
			rowSB.setAttribute("EXTRACTED", extracted);
		} else {
			rowSB.setAttribute("EXTRACTED", "null");
		}
		if(inserted != null) {
			rowSB.setAttribute("INSERTED", aLog.getInserted());
		} else {
			rowSB.setAttribute("INSERTED", "null");
		}
		if(operationTime != null){
			rowSB.setAttribute("DATE", aLog.getOperationDate());
		} else {
			rowSB.setAttribute("DATE", "null");
		}
	}

}
