/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.source.utils;

import it.eng.spago.base.SourceBean;
import it.eng.spago4q.bo.SourceType;
import it.eng.spago4q.utilities.DetailS4Q1ObjectUtil;

public class DetailSourceTypeUtil extends DetailS4Q1ObjectUtil {

	private static final String DAO_NAME = "ESourceTypeDAO";
	private static final String OBJ_NAME = "SOURCETYPE";

	@Override
	protected String getDAOName() {
		return DAO_NAME;
	}

	@Override
	protected Object getObjectFromRequest(SourceBean serviceRequest) {
		SourceType toReturn = new SourceType();
		String name = (String) serviceRequest.getAttribute("name");
		String description = (String) serviceRequest
				.getAttribute("description");
		String extractorClass = (String) serviceRequest
				.getAttribute("extractorclass");

		toReturn.setName(name);
		toReturn.setDescription(description);
		toReturn.setExtractorClass(extractorClass);

		return toReturn;
	}

	@Override
	protected String getObjectName() {
		return OBJ_NAME;
	}

	@Override
	protected void setObjectId(Object object, Integer id) {
		((SourceType) object).setId(id);
	}
}
